/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.RegistrasiLoginUserDto;
import com.portofolio.dto.UidPassDto;
import com.portofolio.service.MapLoginUserToPegawaiService;
import com.portofolio.service.RegistrasiLoginUserService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/loginuser")
public class RegistrasiLoginUserController extends LocaleController {
	@Lazy
	@Autowired
	private RegistrasiLoginUserService loginuserService;

	@Lazy
	@Autowired
	private MapLoginUserToPegawaiService mapLoginUserToPegawaiService;


	@ApiOperation("Api Untuk saveOrUpdate LoginUser")
	@PutMapping("/saveOrUpdate")
	public ResponseEntity<Map<String, Object>> update(@Valid @RequestBody RegistrasiLoginUserDto entity, HttpServletRequest request) {
		Map<String, Object> result = loginuserService.update(entity);
		return RestUtil.getJsonResponse(result);
	}


	@ApiOperation("Api Untuk Menampilkan LoginUser Berdasarkan kode")
	@GetMapping("/findByKode/{kode}")
	public ResponseEntity<Map<String, Object>> findByKode(@PathVariable("kode") Long kode, HttpServletRequest request) {
		Map<String, Object> result = loginuserService.findOne(kode);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan LoginUser Berdasarkan kode")
	@GetMapping("/findByKdPegawai/{kode}")
	public ResponseEntity<Map<String, Object>> findByKdPegawai(@PathVariable("kode") String kode, HttpServletRequest request) {
		Map<String, Object> result = loginuserService.findOneByKdPegawai(kode);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua data pegawaidi loginuser")
	@GetMapping("/findAllPegawaiLoginUser")
	public ResponseEntity<Map<String, Object>> findAllPegawaiLoginUser(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "10") Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaLengkap") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaLengkapOrNik", required = false) String namaLengkapOrNik) {
		Map<String, Object> result = loginuserService.findAll(page, rows, sort, dir, namaLengkapOrNik);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan LoginUser Berdasarkan kode")
	@PostMapping("/findByUidPass")
	public ResponseEntity<Map<String, Object>> findByUidPass(@Valid @RequestBody UidPassDto entity, HttpServletRequest request) {
		Map<String, Object> result = loginuserService.findByUidPass(entity);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk cek email")
	@GetMapping("/cekEmail")
	public ResponseEntity<Map<String, Object>> cekEmail(@RequestParam(value = "email") String email) {
		Map<String, Object> result = loginuserService.cekUserEmail(email);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk cek no mobile")
	@GetMapping("/cekMobile")
	public ResponseEntity<Map<String, Object>> cekMobile(@RequestParam(value = "mobile") String mobile) {
		Map<String, Object> result = loginuserService.cekUserMobile(mobile);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk cek akses ruangan dan modul aplikasi")
	@GetMapping("/findAllAkses")
	public ResponseEntity<Map<String, Object>> findAllAkses(@RequestParam(value = "kode", required = false) Long kode) {
		Map<String, Object> result = loginuserService.findAllAksesByLoginUser(kode);
		return RestUtil.getJsonResponse(result);
	}
}
